<?php

////////////////////////////////////////////////////////////////////////
///
///                 Configuration
///
////////////////////////////////////////////////////////////////////////

require_once ('../../../wp-config.php');

define('GSOM_SS_SUBSCRIBED',0);
define('GSOM_SS_CONFIRMED',1);
define('GSOM_SS_UNSUBSCRIBED',2);



////////////////////////////////////////////////////////////////////////
///
///                 Functions
///
////////////////////////////////////////////////////////////////////////

$responce = array();

function jsonresponce($state,$mess)
{
global $responce;
global $db;
//if ($state == "false") logerror($mess);

header("Content-type: application/json");

$responce['state'] = $state;
$responce['msg'] = $mess;

echo json_encode($responce);
//echo "<pre>";
//print_r(var_dump($responce),true);
//echo "</pre>";    
   
if ($db) $db->close();  
exit();
}

function RequestPresent($param)
{
    if (!isset($_REQUEST[$param]))
    {
        if(func_num_args() == 2)
        {
            $def = func_get_arg(1);
            global ${$param};
            ${$param} = $def;
        }
        else
            jsonresponce('false','required parameter "'.$param.'" is missing in request');
    }
    else
    {
        global ${$param};
        ${$param} = $_REQUEST[$param];
    }
}

////////////////////////////////////////////////////////////////////////
///
///                 Code
///
////////////////////////////////////////////////////////////////////////

//$db = new SQL(false,DB_HOST,DB_USER,DB_PASSWORD,DB_NAME);


// admin.php require a proper login cookie
require_once(ABSPATH . '/wp-admin/admin.php');

//check for correct capability
if ( !is_user_logged_in() )
   jsonresponce('false','Login Failure');    

//check for correct capability
if ( !current_user_can('level_10') ) 
    jsonresponce('false','You do not have admin rights.');
    
RequestPresent('json','[]');

global $wpdb;
$gsom_table_subs = $wpdb->prefix . "gsom_subscribers";


$ejson = json_decode(gsom_mod_remslashes($json),true);

if ((!is_array($ejson)) || empty($ejson))
    jsonresponce('false','There is an error in json request.');
    
$first = true;

$sel = '';
    
foreach($ejson as $item)
{
    if ($first)
        $first = false;
    else
        $sel .= ' OR ';    
    $sel .= ' intId = '.$item;
}


$sql = $wpdb->prepare('DELETE FROM '.$gsom_table_subs.' where '.$sel);
             
$result = $wpdb->query($sql);

if ($result !== false)
    jsonresponce('true','success');
else
    jsonresponce('false',$wpdb->last_error);
?>
